m = 0.4
l = 0.15
b = 0.005
g = 10
k = 0.01

a1 = b/m/l/l
a0 = g/l
b0 = k/m/l/l

K = 1
T = 0.01
phi0 = pi/4

Tsim = 100



% excitation signal
w1 = 0.1
A1 = 5
w2 = 0.2
A2 = 5
w3 = 0.4
A3 = 5
w4 = 0.8
A4 = 5
w5 = 1.6
A5 = 5
w6 = 3.2
A6 = 5

s = tf('s')
C = 170 *(s+2.093) *(s+45.23)/s /(s+171.5)

w = logspace(-1, 1, 10)
w = linspace(0.1, 5, 10)


A = logspace(0.5, -1, 10)*10.5
A = linspace(1, 0.1, 10)*14

w = linspace(0.1,5,10)
w = logspace(-1, 1, 10)
A = linspace(1,0.1,10)*0.2

% A = (1:-0.1:0)*0.15, w = logspace(-1, 1, 10), Multisine vstupni porucha 
% C = 1797.7* (s+0.9088)* (s+11.1)/ s/ (s+1571)
% vede ke spravne identifikaci vseho krom Theta(4)7

% A = (1:-0.1:0)*0.3   w = logspace(-1, 1, 10)  Multisine *0.5 reference
% C = 179.36 *(s+2.093) *(s+45.23)/s /(s+171.5)
% vede ke spravne identifikaci vseho krom Theta(4), kteraje 3x vetsi nez by
% mela byt


% w = linspace(0.1,5,10)
% A = linspace(1,0.1,10)*0.5
% Multisine *0.5 reference
% C = 179.36 *(s+2.093) *(s+45.23)/s /(s+171.5)
% hodne dobry


%% Central difference
sim('ClosedLoopIdentSol.slx')
% arx model
N = min([length(y_sim.Data) length(u_sim.Data)])


clear y u Phi_NS Phi_LS Theta_NS Theta_LS
y = y_sim.Data(1:N)
u = u_sim.Data(1:N)
ydot = ydot_sim.Data(1:N)
ydotdot = ydotdot_sim.Data(1:N)

start = 3
for n = start:N
    Phi_NS(n,:) = [y(n-1)   sin(y(n-1))   y(n-2)    u(n-1)];
    Phi_LS(n,:) = [-y(n-1)  -y(n-2)       u(n-1)    u(n-2)];
    Phi_NS_cont(n, :) = [ -ydot(n)  -sin(y(n))   u(n)];
end

%Theta = inv(Phi'*Phi)*Phi'*y
Theta_NS = Phi_NS\y % Nonlinear regressor with discrete differences
Theta_LS = Phi_LS\y % Linearized regressor
Theta_NS_cont = Phi_NS_cont\ydotdot % Nonlinear regressor with continuous derivatives

H = Phi_NS_cont*inv(Phi_NS_cont'*Phi_NS_cont)*Phi_NS_cont';
epsilon = (eye(length(H))-H)*y(1:N);
s2 = (epsilon'*epsilon)/(N-length(Theta_NS_cont)) % Estimate of covariance of epsilon

cove = s2*(eye(length(H))-H); % Covariance matrix of epsilon

cov_theta = s2 * inv(Phi_NS_cont'*Phi_NS_cont) % Covariance matrix of Theta

%% Validation
Theta0_LS = [(-exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2) - exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2))/(exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)), 1/(exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)), -b0*(4*exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*a0*cos(phi0) + 4*exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*a0*cos(phi0) - 8*a0*cos(phi0)*exp(-T*a1) + exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*a1*sqrt(a1^2 - 4*a0*cos(phi0)) - exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*a1^2 - exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*a1*sqrt(a1^2 - 4*a0*cos(phi0)) - exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*a1^2 + 2*a1^2*exp(-T*a1))/(2*exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*(-a1^2 + 4*a0*cos(phi0))*a0*cos(phi0)), -b0*(4*exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*a0*cos(phi0) + 4*exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*a0*cos(phi0) - exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*a1*sqrt(a1^2 - 4*a0*cos(phi0)) - exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*a1^2 + exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*a1*sqrt(a1^2 - 4*a0*cos(phi0)) - exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*a1^2 - 8*a0*cos(phi0) + 2*a1^2)/(2*exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi0)))*T)/2)*(-a1^2 + 4*a0*cos(phi0))*a0*cos(phi0))]
Theta_LS'

Theta0_NS = [(2/(1+1/2*a1*T))     (-(a0*T^2)/(1+1/2*a1*T))    ((a1*T-2)/(2+a1*T))    (b0*T^2)/(1+1/2*a1*T)]
Theta_NS'


% inverse transform
a1_id = (4/(Theta_NS(1)*T)-2/T )
a0_id = (-2*Theta_NS(2)/(Theta_NS(1)*T^2))
b0_id = (2*Theta_NS(4)/Theta_NS(1)/T^2 )




