function [] = fft_viz(y,T)

    L = length(y);
    NFFT = 2^nextpow2(L);

    f_res = 1/T/length(y);
    f = (0:length(y)-1)*f_res;

    f = 1/T/2*linspace(0,1,NFFT/2+1);
    Y = fft(y,NFFT)/L;
    Ymag = abs(Y);
    figure
    plot(f,Ymag(1:NFFT/2+1))
    title('Single-Sided Amplitude Spectrum of y(t)')
    xlabel('f (Hz)')
    ylabel('|Y(f)|')
    xlim([0 1])
    grid on
end