function [F,G] = predictive_matrices(A,B,C,Np,Nc)
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here
n = length(A);
m = size(B,2);
q = size(C,1);

% matice F
F = zeros(q*Np,n);
F(1:q,:) = C*A;
for k = 1:Np-1
    F(k*q+1:k*q+q,:) = F((k-1)*q+1:(k-1)*q+q,:)*A;
end

% inicializace matice G
G = zeros(q*Np,m*Nc);
% prvn blokov sloupec matice G
for k = 0:Np-1
    G(k*q+1:k*q+q,1:m) = C*A^k*B;
end

% ostatn blokov sloupce matice G
for k = 1:Nc-1
    G(k*q+1:end,k*m+1:k*m+m) = G(1:end-(k*q),1:m);
end

end

