ke = 1
kt = 1
R = 1
beta = 1
alpha = 1

u0 = linspace(0,10,100)
w0 = (-ke*kt/R+sqrt((ke*kt/R)^2+4*kt*u0/R))/(2*alpha)
F0 = beta * w0.*abs(w0)

figure
plot(u0,F0)

title('Static characteristic F_0(u_0)', 'interpreter', 'latex')
xlabel('Input voltage $u_0$ [V]', 'interpreter', 'latex')
ylabel('Output force $F_0$ [N]', 'interpreter', 'latex')

%%

Flin = 2*beta*(ke*kt/2/R/alpha)^2 + beta*kt/R/alpha*u0 - beta*ke*kt/R/2/alpha*2*sqrt((ke*kt/R)^2+4*kt/R*u0)/2/alpha
Ftaylor = (kt* beta*(ke^2 * kt - ke * R * sqrt(kt * (20 * R + kt^2 * kt)/R^2) + 10 * R * alpha)/(2 * R^2 * alpha^2) + ((u0-5) * beta *kt  * (alpha - ((ke * kt)/(R * sqrt((kt * (20* R + ke^2 * kt))/R^2))) ))/(R *alpha^2))
figure
hold on
plot(u0,F0)
plot(u0,Flin)
plot(u0,Ftaylor)