x = randn(1000,1)
T = 0.01
fs = 1/T
fp = 10
[B, A] = butter(4,fp/(fs/2))

y= filtfilt(B,A,x)
%y1 = filter(B,A,filter(B,A,x))

figure
hold on
plot(x)
plot(y)
plot(y1)
legend()

%%
L = length(y);
NFFT = 2^nextpow2(L);

f_res = 1/T/length(y);
f = (0:length(y)-1)*f_res;

f = 1/T/2*linspace(0,1,NFFT/2+1);
Y = fft(y,NFFT)/L;
Ymag = abs(Y);
figure
plot(f,Ymag(1:NFFT/2+1))
title('Single-Sided Amplitude Spectrum of y(t)')
xlabel('f (Hz)')
ylabel('|P1(f)|')
grid on