x = randn(10000,1)
T = 0.01
Fs = 1/T
Fp = 1
order_fir = 100
%Fp = 1
Fs  = 1/T;       
h = fir1(order_fir,Fp/(Fs/2))  % Calculated FIR filter

start = 3
N = length(x)
% Filters the derivative data
y(1:N-(order_fir/2)-2) = x(1:N-(order_fir/2)-2)

for k = start+(order_fir/2):N-(order_fir/2)-2
    yfd = 0;
    for i = 1:order_fir+1
        yfd = yfd + h(i) * y(k - (order_fir/2) + i);
    end
    y(k) = yfd;
end

figure
hold on
plot(x)
plot(y)
legend()
%%
L = length(y);
NFFT = 2^nextpow2(L);

f_res = 1/T/length(y);
f = (0:length(y)-1)*f_res;

f = 1/T/2*linspace(0,1,NFFT/2+1);
Y = fft(y,NFFT)/L;
Ymag = abs(Y);
figure
plot(f,Ymag(1:NFFT/2+1))
title('Single-Sided Amplitude Spectrum of y(t)')
xlabel('f (Hz)')
ylabel('|P1(f)|')
grid on