m = 0.4
l = 0.15
b = 0.005
g = 10
k = 0.01

a1 = b/m/l/l
a0 = g/l
b0 = k/m/l/l

K = 1
T = 0.01
phi = 0*pi/4

u0 = 0*42.4115

% excitation signal
u_ex_var = 5

sim('IdentifikaceNelinearnichParametru.slx')
%% Central difference
% arx model
N = min([length(y_sim.Data) length(u_sim.Data)])

clear y u Phi Theta
y = y_sim.Data(1:N)
u = u_sim.Data(1:N)

for n = 3:N
    Phi(n,:) = [y(n-1)   sin(y(n-1))   y(n-2)    u(n-1)];
end

%Theta = inv(Phi'*Phi)*Phi'*y
Theta = Phi\y %least squares
%% Validation
Theta0_LS = [(-exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2) - exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2))/(exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)), 1/(exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)), -b0*(4*exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*a0*cos(phi) + 4*exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*a0*cos(phi) - 8*a0*cos(phi)*exp(-T*a1) + exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*a1*sqrt(a1^2 - 4*a0*cos(phi)) - exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*a1^2 - exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*a1*sqrt(a1^2 - 4*a0*cos(phi)) - exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*a1^2 + 2*a1^2*exp(-T*a1))/(2*exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*(-a1^2 + 4*a0*cos(phi))*a0*cos(phi)), -b0*(4*exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*a0*cos(phi) + 4*exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*a0*cos(phi) - exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*a1*sqrt(a1^2 - 4*a0*cos(phi)) - exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*a1^2 + exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*a1*sqrt(a1^2 - 4*a0*cos(phi)) - exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*a1^2 - 8*a0*cos(phi) + 2*a1^2)/(2*exp(((-a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*exp(-((a1 + sqrt(a1^2 - 4*a0*cos(phi)))*T)/2)*(-a1^2 + 4*a0*cos(phi))*a0*cos(phi))]

Theta0_NS = [(2/(1+1/2*a1*T))     (-(a0*T^2)/(1+1/2*a1*T))    ((a1*T-2)/(2+a1*T))    (b0*T^2)/(1+1/2*a1*T)]
Theta'

% %% Central difference + forward difference
% % arx model
% N = min([length(y_sim.Data) length(u_sim.Data)])
% 
% clear y u Phi Theta
% y = y_sim.Data(1:N)
% u = u_sim.Data(1:N)
% 
% for n = 3:N
%     Phi(n,:) = [y(n-1) y(n-2) sin(y(n-1)) u(n-1)];
% end
% 
% %Theta = inv(Phi'*Phi)*Phi'*y
% Theta = Phi\y %least squares
%% Forward difference
% % arx model
% N = min([length(y_sim.Data) length(u_sim.Data)])
% 
% clear y u Phi Theta
% y = y_sim.Data(1:N)
% u = u_sim.Data(1:N)
% 
% for n = 3:N
%     Phi(n,:) = [y(n-1) y(n-2) sin(y(n-2)) u(n-2)];
% end
% 
% %Theta = inv(Phi'*Phi)*Phi'*y
% Theta = Phi\y %least squares
% %% Validation
% 
% 
% Theta0 = [(2-a1*T)    (-1+a1*T)   -a0*T^2   b0*T^2]'
% Theta