function [Theta yhat, Phi] = identify(yf,ydotf,yddotf, u, y_offset, start_after_filt)
    stop = min([length(yddotf) length(ydotf) length(yf) length(u)]);
    start = max(15,start_after_filt);
    
    for n = start:stop
        Phi(n-start+1, :) = [ -ydotf(n)  -sin(yf(n))  u(n) ];
    end

    %Theta = pinv(Phi)*yddotf(start:stop);
    Theta = inv(Phi'*Phi)*Phi'*yddotf(start:stop);
    
    yhat=Phi*Theta;
%     H = Phi*inv(Phi'*Phi)*Phi';
% 
%     epsilon_fir = (eye(length(H))-H)*yddotf(start:stop);

    %MG kontrola rezidua

     %eid = yddotf(start:stop)-yhat; %kontrola rezidua, jednodussi vypocet nez opet pres inverzi vyse
     %1+1
% 
%     %MG pozor na pocatecni velkou odchylku v epsilon - ze zaznamu se musi
%     %vyriznout pocatecni cast, kde filtry pro derivace nejsou jeste
%     %vysledovane, tady cca od 13 vzorku dal
% 
%     mean_fir = mean(epsilon_fir) ;
% 
% 
%     s2_fir = ((epsilon_fir-mean_fir)'*(epsilon_fir-mean_fir))/(stop-length(Theta));
% 
%     cove_fir = s2_fir*(eye(length(H))-H);
% 
%     cov_theta_fir = s2_fir * inv(Phi'*Phi);
end