clear all
close all
y_lin = 90
Theta = [0.4554  %Identifikovane parametry
        3.2503
        13.3097]
A = [-Theta(1) -Theta(2)*cos(y_lin*pi/180);
    1   0]
B = [Theta(3);
    0]
C = [0 1]
D = 0
F = tf(ss(A,B,C,D))
Ts = 0.02;
Fd = c2d(F,Ts,'zoh')
plant_ss = ss(Fd)

%y_offset = 40

phi0 = pi/2
u0 = Theta(2)*sin((y_lin)*pi/180)/Theta(3) % ustaleny vstup pro y_lin

t = 0:Ts:100
%%

A = [[plant_ss.A [0;0] [0;0] [0;0]]; [0 0 1 0 0];[0 0 0 1 0]; [0 0 0 0 1]] 
B = [plant_ss.B; 0; 0; 0]
C = [plant_ss.C 0 0 0]
Ce = [plant_ss.C -1 0 0]
D = plant_ss.D


Ard = [plant_ss.A,plant_ss.B;[0 0 1]]
Brd = [plant_ss.B; 0]
Crd = [plant_ss.C 0]

Ld = acker(Ard',Crd', 1*[0 0 0] )'

Frekd = Ard-Ld*Crd
eig(Frekd)

%%
% syms k1 k2 p
% Fsyms = plant_ss.A-[k1;k2]*plant_ss.C
% ddd = vpa(det(p*eye(2) - Fsyms),2)
% poles = [0 0]
% coe = coeffs(ddd,p)
% 
% eq1 = coe(1) == poles(1)*poles(2)
% eq2 = coe(2) == -poles(2)-poles(1)
% %%solve([eq1 eq2], [k1, k2])
% k1ans = solve(eq1)
% k2ans = solve(subs(eq2,k1ans))
% k1ans = subs(k1ans,k2ans)
% Krek = [double(k1ans);double(k2ans)]
% 
% Frek = plant_ss.A - Krek*plant_ss.C
% eig(Frek)
% 
% solve(ddd == (p-poles(1))*(p- poles(2)), [k1, k2])
% 
% rank(obsv(plant_ss.A,plant_ss.C))
% Lrek = place(plant_ss.A',plant_ss.C',[0.1 -0.1])'
% Frek = plant_ss.A - Lrek*plant_ss.C
% eig(Frek)
% 
% 
% 
% rank(obsv(A',C))
% Ar = [[plant_ss.A [0;0]];[0 0 1]] 
% Br = [plant_ss.B; 0]
% Cr = [plant_ss.C 0]
% 
% rank(obsv(Ar,Cr))
% 
% Lz = 1




%Rozsirene stavove matice pro MPC


% 
% rank(obsv(plant_ss.A,plant_ss.C))
% rank(obsv(Ar,Cr))
% 
% Krek = place(Ar,Cr', [-0.5 0.5 0.1])
% eig(Ar-Cr * Krek')
% syms k1 k2 k3
% Arek = Ar-[k1 k2 k3]*Cr'
% Arek = vpa(Arek,3)
% ddd = vpa(det(Arek),3)
% % [ 1.99 - 0.0423*k2 - 1.0*k3 - 0.0425*k1, - 0.0425*k1 - 0.0423*k2 - 1.0*k3 - 0.991,     - 0.0425*k1 - 0.0423*k2 - 1.0*k3]
% % [  1.0 - 0.0423*k2 - 1.0*k3 - 0.0425*k1,         - 0.0425*k1 - 0.0423*k2 - 1.0*k3,     - 0.0425*k1 - 0.0423*k2 - 1.0*k3]
% % [      - 0.0425*k1 - 0.0423*k2 - 1.0*k3,         - 0.0425*k1 - 0.0423*k2 - 1.0*k3, 1.0 - 0.0423*k2 - 1.0*k3 - 0.0425*k1]
% subs(ddd, [k1,k2,k3],[1000, 10, -11])

% parameters
np = 50
nc = 10
% constraints
ub = (1-u0)*ones(nc,1)
lb = (0-u0)*ones(nc,1)
% weights
eW = 1 %output weight
duW = 0.1 %input weight

Q = eW*eye(size(C,1))
R = duW*eye(size(B,2))
cQ = cell(1,np)
cR = cell(1,nc)
cQ(:) = {Q}
cR(:) = {R}
Q = blkdiag(cQ{:}) % np*np
R = blkdiag(cR{:}) % nc*nc

%delta u matrices
K = eye(nc)-triu(ones(nc),-1)+triu(ones(nc),0)
M = zeros(nc,1)
M(1) = -1
L = [0 0 0 1 0]


% prediction matrices
Px = []
Hx = []
P = []
H = []
for r = 1:np
    Hx_row = []
    H_row = []
    for c = 1:np
        Hx_row = [Hx_row mat_pow(A, r-c)*B]
        H_row = [H_row Ce*mat_pow(A,r-c-1)*B]
    end
    Hx = [Hx ; Hx_row]
    H = [H ; H_row]
    Px = [Px ; A^r]   
    P = [P ; Ce*mat_pow(A,r-1)]
end
H = H - diag(diag(H))+eye(length(H))*D %uprava prvku na diagonale


% Move blocking
% Mb lze aplikovat na uk nebo na Hx a H (v nasem pripade se aplikuje na Hx a H)
Mb = [eye(nc);[zeros(np-nc,nc-1) ones(np-nc,1)]]
Hbx = Hx*Mb
Hb = H*Mb

% Inicializace zaznamovych vektoru
w0 = -0.3 % REFERENCNI SIGNAL
z0 = -0.5
z(1) = z0 % PORUCHA
x(:,1) = [0.2;0;w0;0;0] % stavovy vektor rozsireny o referencni hodnotu a posledni u
x0 = [0; 0]
xhat(:,1) = [0 0 0]
% zhat(1) = 0
% v(1) = 0
y(1) = C*x(:,1)
e(1) = Ce*x(:,1)
du(:,1) = K*zeros(nc,1)+M*L*x(:,1)


p = (P'*Q*Hb + L'*M'*R*K);
G = (Hb'*Q*Hb + K'*R*K);

%%

quadprog_sim = sim('quadprog_sim')

figure
subplot(2,1,1)
hold on
% plot(quadprog_sim.quadprog_sim.time,qp_avg.y)
plot(quadprog_sim.quadprog_sim.time,  quadprog_sim.quadprog_sim.signals.values(:,1))
plot(quadprog_sim.quadprog_sim.time,  quadprog_sim.quadprog_sim.signals.values(:,5))
legend({'QP','OASESqp','OASESqphs'},'Interpreter','Latex')
legend({'System output y','Setpoint w'},'Interpreter','Latex')
xlabel('Time [s]','Interpreter','Latex')
ylabel('Pitch angle $\varphi$','Interpreter','Latex')
subplot(2,1,2)
hold on
% plot(quadprog_sim.quadprog_sim.time,qp_avg.y)
plot(quadprog_sim.quadprog_sim.time, quadprog_sim.quadprog_sim.signals.values(:,4))

xlabel('Time [s]','Interpreter','Latex')
ylabel('Input disturbance $z$','Interpreter','Latex')
%% TODO
time_v = (0:length(y)-1)*Ts;
figure

subplot(4,2,[1 2])
hold on
stairs(time_v,y)
plot(time_v,ones(1,length(time_v))*w0,'r')
hold off
title('Output $y$','fontsize',14,'interpreter','latex')
xlabel('Time $[s]$','fontsize',14,'interpreter','latex')

subplot(4,2,3)
stairs(time_v,e)
title('$e = y - w$','fontsize',14,'interpreter','latex')
xlabel('Time $[s]$','fontsize',14,'interpreter','latex')

subplot(4,2,4)
hold on
stairs(time_v(1:length(u)),u)
stairs(time_v(1:length(uOASES)),uOASES)
title('Manipulated variable $u$','fontsize',14,'interpreter','latex')
xlabel('Time $[s]$','fontsize',14,'interpreter','latex')

subplot(4,2,5)
stairs((1:length(du))*Ts,du(1,:))
title('Manipulated difference $\Delta u$','fontsize',14,'interpreter','latex')
xlabel('Time $[s]$','fontsize',14,'interpreter','latex')

subplot(4,2,6)
hold on
plot(time_v, z)
plot(time_v, xhat(3,:))
title('Disturbance','fontsize',14,'interpreter','latex')
xlabel('Time $[s]$','fontsize',14,'interpreter','latex')
legend('Model disturbance', 'Reconstructed disturbance')

subplot(4,2,7)
hold on
plot(time_v,xhat(1,:))
plot(time_v,xhat(2,:))
title('Reconstructed states $\hat{x}$','fontsize',14,'interpreter','latex')
legend('x1', 'x2')
xlabel('Time $[s]$','fontsize',14,'interpreter','latex')

subplot(4,2,8)
hold on
plot(time_v(1:end-1), u+xhat(3,1:end-1))
plot(time_v(1:end-1), lb_star(1,:))
plot(time_v(1:end-1), ub_star(1,:))
xlim([Ts time_v(end)])
legend('Calculated u(k)', 'Offset lower bound', 'Offset upper bound')
title('MPC calculated u(k)','fontsize',14,'interpreter','latex')
ylabel('$u(k)$','fontsize',14,'interpreter','latex')
xlabel('Time $[s]$','fontsize',14,'interpreter','latex')

figure
hold on
subplot(3,1,1)
hold on
plot(JOASES)
plot(feval)
ylabel('Ucelova funkce pro qpOASES')
subplot(3,1,2)
plot(J)
ylabel('Ucelova funkce pro quadprog')
subplot(3,1,3)
plot(J-feval)
ylabel('Rozdil ucelovych funkci')
%%
% 
% 
% figure
% subplot(2,2,1)
% hold on
% stairs(time_v,y)
% plot(time_v,ones(1,length(time_v))*w0,'r')
% hold off
% title('regulovana velicina y')
% xlabel('t[s]')
% subplot(2,2,2)
% stairs(time_v,e)
% title('regulacni odchylka e')
% xlabel('t[s]')
% subplot(2,2,3)
% stairs(time_v(1:length(u)),u)
% title('akcni zasah u')
% xlabel('t[s]')
% subplot(2,2,4)
% stairs((1:length(du))*Ts,du(1,:))
% title('zmena akcniho zasahu du')
% xlabel('t[s]')

% 
% figure
% plot(tfull,yfull())

figure
hold on
plot(tfull, yfull(:,1))
plot(time_v, y+y_lin*pi/180)
plot([0, time_v(end)], ones(1,2)*(y_lin*pi/180+w0))
legend('Nonlinear system', 'Linear system', 'Setpoint')
title('MPC control output','fontsize',14,'interpreter','latex')
ylabel('$\varphi [rad]$','fontsize',14,'interpreter','latex')
xlabel('Time $[s]$','fontsize',14,'interpreter','latex')

% figure
% hold on
% plot(tfull, (yfull(:,1) - (y_lin*pi/180 + w0)))
% plot(time_v, y-w0)
% plot([0, time_v(end)], ones(1,2)*(0))
% xlim([Ts time_v(end)])
% legend('Nonlinear system', 'Linear system', 'Setpoint')
% title('Output error','fontsize',14,'interpreter','latex')
% ylabel('$\varphi [rad]$','fontsize',14,'interpreter','latex')
% xlabel('Time $[s]$','fontsize',14,'interpreter','latex')

% figure
% hold on
% subplot(2,1,1)
% plot(time_v, xhat(3,:))
% title('Porucha','fontsize',14,'interpreter','latex')
% xlabel('Time $[s]$','fontsize',14,'interpreter','latex')
% subplot(2,1,2)
% hold on
% plot(time_v,xhat(1,:))
% plot(time_v,xhat(2,:))
% title('\hat{x}','fontsize',14,'interpreter','latex')
% xlabel('Time $[s]$','fontsize',14,'interpreter','latex')

% figure
% hold on
% plot(time_v(1:end-1), u+xhat(3,1:end-1))
% plot(time_v(1:end-1), lb_star(1,:))
% plot(time_v(1:end-1), ub_star(1,:))
% xlim([Ts time_v(end)])
% legend('Calculated u(k)', 'Offset lower bound', 'Offset upper bound')
% title('MPC calculated u(k)','fontsize',14,'interpreter','latex')
% ylabel('$u(k)$','fontsize',14,'interpreter','latex')
% xlabel('Time $[s]$','fontsize',14,'interpreter','latex')


% 
% [X,Y] = meshgrid(-5000:500:5000);
% xJ = X(:);
% y = Y(:);
% sx = size(X);
% %G = [1 -0.5;-0.5 2]
% a=0.5*diag([xJ y]*G*[xJ';y'])+(f'*[xJ';y'])';
% %a=0.5*diag([xJ y]*G*[xJ';y'])';
% Z = reshape(a,sx);
% 
% figure
% surf(X,Y,Z)
% xlabel('u(1)')
% ylabel('u(2)')
% zlabel('J')
% title('Funkcional J(u) pro np = 5 a nc = 2')